VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Svuotamento di un vaso"
   ClientHeight    =   3750
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4530
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3750
   ScaleWidth      =   4530
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txt_TempoScar 
      Height          =   285
      Left            =   2640
      TabIndex        =   6
      Top             =   3000
      Width           =   1455
   End
   Begin VB.TextBox txt_Flusso 
      Height          =   285
      Left            =   2640
      TabIndex        =   4
      Top             =   2280
      Width           =   1455
   End
   Begin VB.TextBox txt_Press 
      Height          =   285
      Left            =   2640
      TabIndex        =   1
      Top             =   1440
      Width           =   1455
   End
   Begin VB.CommandButton cmd_Apri 
      Caption         =   "Apri"
      Height          =   495
      Left            =   2520
      TabIndex        =   0
      Top             =   480
      Width           =   1455
   End
   Begin VB.Label Label3 
      Caption         =   "Tempo di scarico:"
      Height          =   255
      Left            =   2640
      TabIndex        =   5
      Top             =   2760
      Width           =   1815
   End
   Begin VB.Label Label2 
      Caption         =   "Flusso:"
      Height          =   255
      Left            =   2640
      TabIndex        =   3
      Top             =   2040
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Pressione (sul fondo):"
      Height          =   255
      Left            =   2640
      TabIndex        =   2
      Top             =   1200
      Width           =   1695
   End
   Begin VB.Line Line4 
      BorderColor     =   &H00FF8080&
      BorderWidth     =   4
      X1              =   1440
      X2              =   1560
      Y1              =   3480
      Y2              =   3240
   End
   Begin VB.Shape shp_H2O 
      FillColor       =   &H00FF8080&
      FillStyle       =   0  'Solid
      Height          =   2175
      Left            =   480
      Top             =   720
      Width           =   1335
   End
   Begin VB.Line Line3 
      BorderColor     =   &H00FF8080&
      BorderWidth     =   4
      X1              =   1680
      X2              =   1560
      Y1              =   3480
      Y2              =   3240
   End
   Begin VB.Line Line2 
      BorderColor     =   &H00FF8080&
      BorderWidth     =   4
      X1              =   1680
      X2              =   1800
      Y1              =   3240
      Y2              =   3480
   End
   Begin VB.Line Line1 
      BorderColor     =   &H00FF8080&
      BorderWidth     =   4
      X1              =   1440
      X2              =   1320
      Y1              =   3240
      Y2              =   3480
   End
   Begin VB.Shape Shape2 
      FillStyle       =   0  'Solid
      Height          =   375
      Left            =   1440
      Top             =   2880
      Width           =   255
   End
   Begin VB.Shape Shape1 
      BorderWidth     =   3
      FillColor       =   &H00FF8080&
      Height          =   2415
      Left            =   480
      Top             =   480
      Width           =   1335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

' ---------------------------------------------------------------------------
' A. Veneziani - Programma simulante lo svuotamento di un vaso pieno d'acqua
'                (simulazione di un particolare sistema idraulico)
'
' Realizzato in Visual Basic 6.0
'
' ---------------------------------------------------------------------------

Option Explicit

' Valori iniziali e non variabili, indicati come costanti programmative
Const Area_Vaso As Single = 100
Const H_Ini As Single = 10
Const Sup_Scarico As Single = 5
Const Peso_Sp As Single = 1
Const g As Single = 9.81
Const Dt As Single = 0.001

' variabili di programma
Dim V_Liquido As Single, DV As Single   ' Dv = variazione volume liquido in Dt
Dim Press As Single, Flusso As Single
Dim T As Single, H As Single            ' T = variabile tempo, H altezza superficie liquido
Dim H_H2O_Ini As Integer, H_H2O_Prec As Single   ' Memorie di altezze del liquido


' avvio della simulazione di svuotamento....
Private Sub cmd_Apri_Click()

   T = 0   ' pone T al valore iniziale (0 per convenzione)
   Do While (True)
       DV = Flusso * Dt    ' calcolo della variazione di volume, dato il flusso ed un tempo dt
       V_Liquido = V_Liquido - DV     ' variazione del volume (dato il liquido scaricato)
       H = V_Liquido / Area_Vaso        ' variazione conseguente altezza linquido
       
       If H < 0 Then Exit Do     ' scarica finche' c'e' acqua  (processo finito)
       Debug.Print H


       Press = H * Peso_Sp       ' pressione dovuta alla nuova altezza del liquido
       Flusso = Sup_Scarico * Sqr(2 * g * H)  ' flusso dovuto alla nuova pressione
       
       txt_Press.Text = Press     ' indicazione sulla GUI di pressione e flusso correnti
       txt_Flusso.Text = Flusso
       txt_TempoScar.Text = T
       
       T = T + Dt        ' evoluzione del tempo
       
       '-------------------------------------------------------------------------------------
       ' Operazioni per la gestione della visualizzazione del fenomeno sulla GUI
       
       ' implementazione dell'animazione della shape rappresentante il liquido...
       H_H2O_Prec = shp_H2O.Height
       shp_H2O.Height = H_H2O_Ini * (H / H_Ini)
       shp_H2O.Top = shp_H2O.Top + (H_H2O_Prec - shp_H2O.Height)
       
       ' variazione, in tempo reale, della indicazione grafica del getto
       Select Case Flusso
           Case Is < 1:    SpessoreGetto (1)
           Case 1 To 10:   SpessoreGetto (2)
           Case 10 To 20:  SpessoreGetto (3)
           Case Is > 20:   SpessoreGetto (4)
       End Select
       '--------------------------------------------------------------------------------------
       
       ' servono a permette al sistema operativo (Windows) di riprendere
       ' il controllo del programma in ciclo
       DoEvents: DoEvents: DoEvents: DoEvents
       DoEvents: DoEvents: DoEvents: DoEvents
   Loop
   
End Sub

Private Sub Form_Load()
    ' settaggi di una serie di valori inziali...
    H = H_Ini
    H_H2O_Ini = shp_H2O.Height
    ' calcolo dei valori iniziali di volume del liquido
    ' pressione e flusso iniziale...
    V_Liquido = Area_Vaso * H
    Press = H * Peso_Sp
    Flusso = Sup_Scarico * Sqr(2 * g * H)
End Sub

' la form e' stata chiusa, e quindi il programma viene
' arrestato (ci non e' automatico in programma con GUI)
Private Sub Form_Unload(Cancel As Integer)
    End
End Sub

' regola graficamente lo spessore del getto, secondo il valore del parametro
Sub SpessoreGetto(S As Integer)
     Line1.BorderWidth = S
     Line2.BorderWidth = S
     Line3.BorderWidth = S
     Line4.BorderWidth = S
End Sub
